;------------------------------------------------------------
;	ETHCRD by Padgett (C) 1993 all rights reserved
;	version 1.2, October, 1993
;
; Header is left over from some ancient program but still works

	PAGE	,132
S00000	SEGMENT BYTE PUBLIC 'code'
	ASSUME	CS:S00000
	ASSUME	SS:S00000
	ASSUME	DS:S00000
H00000	DB	256 DUP(?)
P00100	PROC	FAR
	ASSUME	ES:S00000
start:	jmp	begin

begin:
	mov	bx,80h
	add	bl,byte ptr [bx]
	mov	bl, byte ptr [bx]
	and	bl,5fh
	cmp	bl,'H'
	jnz	nosw
	mov	byte ptr swit,bl
nosw:

	mov	dx,offset logo
	call	wrt
;
;-------------------------------------------------------------------
;	First we look for a packet driver. This will be in the range
;	of interrupts 60h-80h
;
	xor	ax,ax
	mov	ds,ax
	mov	ax,60h
intlp:  push	ax
	push	ds
	mov	dl,4
	mul	dl
	mov	bx,ax
	lds	si,dword ptr ds:[bx]
	push	ds
	pop	dx
	or	dx,si
	jz	next
	add	si,3
	mov	di,offset pkt
	mov	cx,9
	rep	cmpsb
	jcxz	found
;
next:	pop	ds
	pop	ax
	inc	ax
	cmp	ax,80h
	jbe	intlp
;------------------------------------------
;  No driver found - say so & look for an IPX driver
	push	cs
	pop	ds
	mov 	dx,offset nodrv
	call	wrt
	jmp	ipxa
;-------------------------------------------
;  Found a Packet Driver
found:	pop	dx
	pop	ax
	push	cs
	pop	ds
	mov	byte ptr pint,al
;
;	write interrupt number
;
	cmp	byte ptr [swit],0
	jnz	nint
	push	ax
	mov	al,2
	mov	byte ptr flag, al	;since we just saved ax, fix return
	mov	dx,offset intno
	call	wrt
	pop	ax
	call	wrtbyt
nint:
;
; 	get name
;
	mov	dx,offset dvrnam
	call	wrt
	mov	ax,1ffh
	xor	bx,bx
	call	pnt
	jc	faili
	call	wrtz
	mov	word ptr cs:[namds], ds
	mov	word ptr cs:[namdx], si

;
; get address
;
	push	cs
	pop	ds
	push	cs
	pop	es
	mov	ax,600h
	xor	bx,bx
	mov	cx,40h
	mov	di,offset buf
	push	di
	call	pnt
	pop	si
	jnc	addlpa
;-----------------------------------------------
; try, try, again (special for Bruce's driver)
; - only if we got a name but type 6 call did not work
; 
	mov	es,word ptr namds
	mov	si,offset buf
	mov	di,5
	mov	cx,100h
	xor	ax,ax
	repnz	scasb
	jnz	noname
;
	push	es
	pop	ds
	push	cs
	pop	es
	xchg	di,si
	add	si,1dh
	mov	cx,6
	rep	movsb
;
; Check for valid SMC address
;
	push	cs
	pop	ds
	mov	cx,3
	mov	di,offset buf
	mov	si,offset smc
	repe	cmpsb
	jnz	faili
	jmp	addlpa
;------------------------------------------------
faili:	mov	dx,offset ifail
	call	wrt	
;------------------------------------------------
;
;   For IPX, the first step is to find the driver
;
ipxa:	mov	ax,7a00h
	int	2fh
	cmp	al,0ffh
	jne	noipx
	mov	word ptr [ipx],di
	mov	word ptr [ipx+2],es
;
;  Function 9 will return the address after 4 network bytes
;
	mov	bx,9
	push	cs
	pop	es
	mov	si, offset buf-4	;so buf always contains the address
	call 	dword ptr ds:[ipx]
	jmp	addlpb
;-------------------------------------------------
;  However we found the address, we did so...
;  
addlpa:
	mov 	dx,offset crlf
	call	wrt
addlpb:	mov	dx,offset padd
	call	wrt
	mov	cx,6
	mov	si,offset buf
addlp:	
	cmp	cx,6
	jz	add2
	mov 	al,':'
	call	wrtb
add2:	lodsb
	push	cx
	call	wrtbyt
;	mov	al,' '
;	call	wrtb
	pop	cx
	loop	addlp
;
;   Now see if we can identify it
;
	mov	dx,offset crlf
	call	wrt
;
	mov	di,offset codbuf
codlp:	mov	si,offset buf
	cmp	byte ptr [di],0ffh
	jz	noname
	mov	cx,3
	repe	cmpsb
	jz	found2
	mov	al,0ah
	mov	cx,100
	repnz	scasb
	jcxz	noname
	jmp	codlp
;
found2: mov	si,di
fnd1:	lodsb
	cmp	al,0ah
	jz	fnd2
	call	wrtb
	jmp	fnd1
fnd2:
	call	wrtb
	jmp	endit
;
noname:	mov	dx,offset nonam
	call	wrt
endit:	mov	al, byte ptr flag
	inc	al
	mov	byte ptr flag, al
	jmp	done
;----------------------------------------
; Subroutines
;
; Write routines all use Int 21 so that redirection/piping works
;
wrtbyt:				;convert a hex byte to ASCII & print	
	push	ax
	mov	dx,offset wrtb2
	push	dx
	mov 	cx,4
	shr	al,cl
wrtb1:	and	ax,0fh
	cmp	al,9
	jbe	skp
	add	al,7
skp:	add	al,30h
	call	wrt1
	retn
wrtb2:	pop	ax
	jmp	wrtb1
;
;-------------------------------------
; Where we store the entry to the packet driver
;
pnt:	db	0cdh	; Int
pint	db	00h	; Which Int
	retn
;
;--------------------------------------
; write an ASCIIZ string
;
wrtz:
	push	dx
wrtz1:	lodsb
	or	al,al
	jnz	wrtz2
	pop	dx
	retn
wrtz2:
	call	wrtb
	jmp	wrtz1
;--------------------------------------
; Write a single char
;
wrtb:
	cmp	byte ptr cs:[swit],0
	jnz	dne
wrt1:	mov	dl,al
	mov	ah,2
	int	21h
	retn
;--------------------------------------
; Write a $ terminated string
;
wrt:	cmp	byte ptr cs:[swit],0
	jnz	dne
	mov 	ah,09
	int	21h
dne:	retn
;--------------------------------------
; If no IPX either
;
noipx:	mov	dx,offset ipfail
	call	wrt
;--------------------------------------
; Endit
;
done:	mov	al, byte ptr flag
	mov	ah,4ch
	INT	21H
;---------------------------------------
; DATA
;
namdx	dw	0
namds	dw	0
ipx	dw	0
ipxs	dw	0
logo	db	0dh,0ah,"ETHCRD v1.2 by Padgett (C)1993"
	db	" - IDs from Michael A. Patton's EtherNet-Codes"
	db	0dh,0ah,24h
ifail	db	' Unsupported Interrupt, checking for IPX',24h
ipfail	db	' - IPX Driver not found',0dh,0ah,24h
nodrv	db	0ah,'Ethernet packet driver not found, checking for IPX',24h	
padd	db	0dh,0ah,'Hardware Address: ',24h
dvrnam	db	'h  Packet Driver Name: ',24h
intno	db	'Interrupt: ',24h

nonam   db	'Unknown Driver or Card Type'
crlf	db	0dh,0ah,24h
pkt	db	'PKT DRVR',0
flag	db	0
swit	db	0
;
;-------------------------------------------
; Card identification data
; from EtherNet-Codes dated 8 April, 1993
; Format: 3 Mfg ID bytes followed by ASCII info, followed by 0dh,0ah pair
; Last entry is 0ffh,0ffh,0ffh
;
; NOTE: not all codes are found on PC boards, some are for other platforms
;
codbuf  db 0
 db      000h,002h,'BBN (was internal usage only, no longer used)',0dh,0ah
 db 000h,000h,00Ch,'Cisco',0dh,0ah
 db 000h,000h,00Eh,'Fujitsu',0dh,0ah
 db 000h,000h,00Fh,'NeXT',0dh,0ah
 db 000h,000h,010h,'Hughes LAN Systems (formerly Sytek)',0dh,0ah
 db 000h,000h,011h,'Tektronix',0dh,0ah
 db 000h,000h,015h,'Datapoint Corporation ',0dh,0ah
 db 000h,000h,018h,'Webster Computer Corporation Appletalk/Ethernet Gateway',0dh,0ah
 db 000h,000h,01Ah,'AMD (?)',0dh,0ah
 db 000h,000h,01Bh,'Novell >> now Eagle Technology',0dh,0ah
 db 000h,000h,01Dh,'Cabletron',0dh,0ah
 db 000h,000h,020h,'DIAB (Data Intdustrier AB)',0dh,0ah
 db 000h,000h,021h,'SC&C',0dh,0ah
 db 000h,000h,022h,'Visual Technology',0dh,0ah
 db 000h,000h,023h,'ABB Automation AB, Dept. Q',0dh,0ah
 db 000h,000h,029h,'IMC',0dh,0ah
 db 000h,000h,02Ah,'TRW',0dh,0ah
 db 000h,000h,03Ch,'Auspex',0dh,0ah
 db 000h,000h,03Dh,'AT&T',0dh,0ah
 db 000h,000h,044h,'Castelle',0dh,0ah
 db 000h,000h,046h,'ISC-Bunker Ramo, An Olivetti Company',0dh,0ah
 db 000h,000h,049h,'Apricot Ltd.',0dh,0ah
 db 000h,000h,04Bh,'APT A.P.T. Appletalk WAN router',0dh,0ah
 db 000h,000h,04Fh,'Logicraft 386-Ware P.C. Emulator',0dh,0ah
 db 000h,000h,051h,'Hob Electronic Gmbh & Co. KG',0dh,0ah
 db 000h,000h,052h,'ODS',0dh,0ah
 db 000h,000h,055h,'AT&T',0dh,0ah
 db 000h,000h,05Ah,'SK (Schneider & Koch in Europe and Syskonnect outside of Europe)',0dh,0ah
 db 000h,000h,05Ah,'Xerox 806 (unregistered)',0dh,0ah
 db 000h,000h,05Dh,'RCE',0dh,0ah
 db 000h,000h,05Eh,'U.S. Department of Defense (IANA)',0dh,0ah
 db 000h,000h,05Fh,'Sumitomo (?)',0dh,0ah
 db 000h,000h,061h,'Gateway Communications',0dh,0ah
 db 000h,000h,062h,'Honeywell',0dh,0ah
 db 000h,000h,065h,'Network General',0dh,0ah
 db 000h,000h,069h,'Silicon Graphics(?)',0dh,0ah
 db 000h,000h,06Bh,'MIPS',0dh,0ah
 db 000h,000h,06Eh,'Artisoft, Inc.',0dh,0ah
 db 000h,000h,077h,'Interphase [Used in other systems, e.g. MIPS, Motorola]',0dh,0ah
 db 000h,000h,078h,'Labtam Australia',0dh,0ah
 db 000h,000h,079h,'Net Ware (?)',0dh,0ah
 db 000h,000h,07Ah,'Ardent',0dh,0ah
 db 000h,000h,07Bh,'Research Machines',0dh,0ah
 db 000h,000h,07Dh,'Cray Research Superservers,Inc [Also Harris (3M) (old)]',0dh,0ah
 db 000h,000h,07Fh,'Linotronic',0dh,0ah
 db 000h,000h,080h,'Dowty Network Services [Also "Harris (3M) (new)" "Imagen(?)"]',0dh,0ah
 db 000h,000h,081h,'Synoptics',0dh,0ah
 db 000h,000h,084h,'Aquila (?), ADI Systems Inc.(?)',0dh,0ah
 db 000h,000h,086h,'Gateway Communications Inc. (also Megahertz Corporation?)',0dh,0ah
 db 000h,000h,089h,'Cayman Systems Gatorbox',0dh,0ah
 db 000h,000h,08Ah,'Datahouse Information Systems',0dh,0ah
 db 000h,000h,08Eh,'Jupiter(?), Solbourne(?)',0dh,0ah
 db 000h,000h,093h,'Proteon',0dh,0ah
 db 000h,000h,094h,'Asante MAC',0dh,0ah
 db 000h,000h,095h,'Sony/Tektronix',0dh,0ah
 db 000h,000h,097h,'Epoch',0dh,0ah
 db 000h,000h,098h,'Cross Com',0dh,0ah
 db 000h,000h,09Fh,'Ameristar Technology',0dh,0ah
 db 000h,000h,0A0h,'Sanyo Electronics',0dh,0ah
 db 000h,000h,0A2h,'Wellfleet',0dh,0ah
 db 000h,000h,0A3h,'Network Application Technology (NAT)',0dh,0ah
 db 000h,000h,0A4h,'Acorn',0dh,0ah
 db 000h,000h,0A5h,'Compatible Systems Corporation',0dh,0ah
 db 000h,000h,0A6h,'Network General (internal assignment, not for products)',0dh,0ah
 db 000h,000h,0A7h,'Network Computing Devices (NCD) X-terminals',0dh,0ah
 db 000h,000h,0A8h,'Stratus Computer, Inc.',0dh,0ah
 db 000h,000h,0A9h,'Network Systems',0dh,0ah
 db 000h,000h,0AAh,'Xerox Xerox machines',0dh,0ah
 db 000h,000h,0ACh,'Apollo',0dh,0ah
 db 000h,000h,0AFh,'Nuclear Data Acquisition Interface Modules (AIM)',0dh,0ah
 db 000h,000h,0B0h,'RND (RAD Network Devices)',0dh,0ah
 db 000h,000h,0B1h,'Alpha Microsystems Inc.',0dh,0ah
 db 000h,000h,0B3h,'CIMLinc',0dh,0ah
 db 000h,000h,0B4h,'Edimax',0dh,0ah
 db 000h,000h,0B5h,'Datability Terminal Servers',0dh,0ah
 db 000h,000h,0B7h,'Dove Fastnet',0dh,0ah
 db 000h,000h,0BBh,'TRI-DATA Systems Inc. Netway products, 3274 emulators',0dh,0ah
 db 000h,000h,0BCh,'Allen-Bradley',0dh,0ah
smc db 000h,000h,0C0h,'Western Digital now  SMC (Std. Microsystems Corp.)',0dh,0ah
 db 000h,000h,0C6h,'HP Intelligent Networks Operation (formerly Eon Systems)',0dh,0ah
 db 000h,000h,0C8h,'Altos',0dh,0ah
 db 000h,000h,0C9h,'Emulex Terminal Servers',0dh,0ah
 db 000h,000h,0CCh,'Densan Co., Ltd.',0dh,0ah
 db 000h,000h,0D0h,'Develcon Electronics, Ltd.',0dh,0ah
 db 000h,000h,0D1h,'Adaptec, Inc. "Nodem" product',0dh,0ah
 db 000h,000h,0D3h,'Wang Labs',0dh,0ah
 db 000h,000h,0D4h,'PureData',0dh,0ah
 db 000h,000h,0D7h,'Dartmouth College (NED Router)',0dh,0ah
 db 000h,000h,0D8h,'old Novell NE1000s ~<=1987 ? (maybe also 3Com?)',0dh,0ah
 db 000h,000h,0DDh,'Gould',0dh,0ah
 db 000h,000h,0DEh,'Unigraph',0dh,0ah
 db 000h,000h,0E2h,'Acer Counterpoint',0dh,0ah
 db 000h,000h,0E3h,'Integrated Micro Products Ltd',0dh,0ah
 db 000h,000h,0E6h,'Aptor Produits De Comm Indust',0dh,0ah
 db 000h,000h,0E8h,'Accton Technology Corporation',0dh,0ah
 db 000h,000h,0E9h,'ISICAD, Inc.',0dh,0ah
 db 000h,000h,0EDh,'April',0dh,0ah
 db 000h,000h,0EEh,'Network Designers Limited(?)',0dh,0ah
 db 000h,000h,0EFh,'Alantec',0dh,0ah
 db 000h,000h,0F0h,'Samsung',0dh,0ah
 db 000h,000h,0F3h,'Gandalf Data Ltd. - Canada',0dh,0ah
 db 000h,000h,0F4h,'Allied Telesis, Inc.',0dh,0ah
 db 000h,000h,0F6h,'A.M.C. (Applied Microsystems Corp.)',0dh,0ah
 db 000h,000h,0F8h,'DEC (?)',0dh,0ah
 db 000h,000h,0FDh,'High Level Hardware (Orion, UK)',0dh,0ah
 db 000h,001h,002h,'BBN (Bolt Beranek and Newman, Inc.) internal usage (not registered)',0dh,0ah
 db 000h,001h,043h,'IEEE 802',0dh,0ah
 db 000h,001h,063h,'NDC  (National Datacomm Corporation)',0dh,0ah
 db 000h,001h,068h,'W&G  (Wandel & Goltermann)',0dh,0ah
 db 000h,001h,0C8h,'Thomas Conrad Corp.',0dh,0ah
 db 000h,008h,052h,'Technically Elite Concepts',0dh,0ah
 db 000h,008h,055h,'Fermilab',0dh,0ah
 db 000h,017h,000h,'Kabel',0dh,0ah
 db 000h,040h,088h,'Mobuis NuBus (Mac) combination video/EtherTalk',0dh,0ah
 db 000h,040h,00Bh,'Crescendo (?)',0dh,0ah
 db 000h,040h,00Ch,'General Micro Systems, Inc.',0dh,0ah
 db 000h,040h,00Dh,'LANNET Data Communications',0dh,0ah
 db 000h,040h,010h,'Sonic Mac Ethernet interfaces',0dh,0ah
 db 000h,040h,014h,'Comsoft Gmbh',0dh,0ah
 db 000h,040h,015h,'Ascom (?)',0dh,0ah
 db 000h,040h,01Fh,'Colorgraph Ltd',0dh,0ah
 db 000h,040h,027h,'Sigma (?)',0dh,0ah
 db 000h,040h,02Ah,'Canoga-Perkins',0dh,0ah
 db 000h,040h,02Bh,'TriGem',0dh,0ah
 db 000h,040h,02Fh,'XDI (?)',0dh,0ah
 db 000h,040h,030h,'GK Computer',0dh,0ah
 db 000h,040h,033h,'Addtron Technology Co., Ltd.',0dh,0ah
 db 000h,040h,03Ch,'Forks, Inc.',0dh,0ah
 db 000h,040h,041h,'Fujikura Ltd.',0dh,0ah
 db 000h,040h,04Ch,'Hypertec Pty Ltd.',0dh,0ah
 db 000h,040h,050h,'Ironics, Incorporated',0dh,0ah
 db 000h,040h,05Bh,'Funasset Limited',0dh,0ah
 db 000h,040h,066h,'Hitachi Cable, Ltd.',0dh,0ah
 db 000h,040h,068h,'Extended Systems',0dh,0ah
 db 000h,040h,06Eh,'Corollary, Inc.',0dh,0ah
 db 000h,040h,074h,'Cable and Wireless',0dh,0ah
 db 000h,040h,076h,'AMP Incorporated',0dh,0ah
 db 000h,040h,07Fh,'Agema Infrared Systems AB',0dh,0ah
 db 000h,040h,08Ch,'Axis Communications AB',0dh,0ah
 db 000h,040h,08Eh,'CXR/Digilog',0dh,0ah
 db 000h,040h,092h,'ASP Computer Products, Inc.',0dh,0ah
 db 000h,040h,095h,'Eagle Technologies',0dh,0ah
 db 000h,040h,09Dh,'DigiBoard Ethernet-ISDN bridges',0dh,0ah
 db 000h,040h,09Eh,'Concurrent Technologies  Ltd.',0dh,0ah
 db 000h,040h,0A6h,'Cray Research Inc.',0dh,0ah
 db 000h,040h,0AEh,'Delta Controls, Inc.',0dh,0ah
 db 000h,040h,0B4h,'3COM K.K.',0dh,0ah
 db 000h,040h,0B6h,'Computerm Corporation',0dh,0ah
 db 000h,040h,0C1h,'Bizerba-Werke Wilheim Kraut',0dh,0ah
 db 000h,040h,0C2h,'Applied Computing Devices',0dh,0ah
 db 000h,040h,0C3h,'Fischer and Porter Co.',0dh,0ah
 db 000h,040h,0C5h,'Micom Communications Corp.',0dh,0ah
 db 000h,040h,0C6h,'Fibernet Research, Inc.',0dh,0ah
 db 000h,040h,0C8h,'Milan Technology Corp.',0dh,0ah
 db 000h,040h,0D4h,'Gage Talker Corp.',0dh,0ah
 db 000h,040h,0DFh,'Digalog Systems, Inc.',0dh,0ah
 db 000h,040h,0E7h,'Arnos Instruments & Computer',0dh,0ah
 db 000h,040h,0E9h,'Accord Systems, Inc.',0dh,0ah
 db 000h,040h,0F1h,'Chuo Electronics Co., Ltd.',0dh,0ah
 db 000h,040h,0F4h,'Cameo Communications, Inc.',0dh,0ah
 db 000h,040h,0F9h,'Combinet',0dh,0ah
 db 000h,040h,0FBh,'Cascade Communications Corp.',0dh,0ah
 db 000h,060h,08Ch,'3Com (1990 onwards)',0dh,0ah
 db 000h,080h,004h,'Antlow Computers, Ltd.',0dh,0ah
 db 000h,080h,005h,'Cactus Computer Inc.',0dh,0ah
 db 000h,080h,006h,'Compuadd Corporation',0dh,0ah
 db 000h,080h,007h,'Dlog NC-Systeme',0dh,0ah
 db 000h,080h,00Fh,'SMC (Standard Microsystem Corp.)',0dh,0ah
 db 000h,080h,010h,'Commodore',0dh,0ah
 db 000h,080h,017h,'PFU',0dh,0ah
 db 000h,080h,019h,'Dayna Communications "Etherprint" product',0dh,0ah
 db 000h,080h,01Ah,'Bell Atlantic',0dh,0ah
 db 000h,080h,01Bh,'Kodiak Technology',0dh,0ah
 db 000h,080h,021h,'Newbridge Networks Corporation',0dh,0ah
 db 000h,080h,023h,'Integrated Business Networks',0dh,0ah
 db 000h,080h,024h,'Kalpana',0dh,0ah
 db 000h,080h,029h,'Microdyne Corporation',0dh,0ah
 db 000h,080h,02Dh,'Xylogics, Inc. Annex terminal servers',0dh,0ah
 db 000h,080h,02Eh,'Plexcom, Inc.',0dh,0ah
 db 000h,080h,033h,'Formation (?)',0dh,0ah
 db 000h,080h,034h,'SMT-Goupil',0dh,0ah
 db 000h,080h,035h,'Technology Works',0dh,0ah
 db 000h,080h,037h,'Ericsson Business Comm.',0dh,0ah
 db 000h,080h,038h,'Data Research & Applications',0dh,0ah
 db 000h,080h,03Bh,'APT Communications, Inc.',0dh,0ah
 db 000h,080h,03Eh,'Synernetics',0dh,0ah
 db 000h,080h,03Fh,'Hyundai Electronics',0dh,0ah
 db 000h,080h,042h,'Force Computers',0dh,0ah
 db 000h,080h,04Ch,'Contec Co., Ltd.',0dh,0ah
 db 000h,080h,04Dh,'Cyclone Microsystems, Inc.',0dh,0ah
 db 000h,080h,051h,'ADC Fibermux',0dh,0ah
 db 000h,080h,052h,'Network Professor',0dh,0ah
 db 000h,080h,05Bh,'Condor Systems, Inc.',0dh,0ah
 db 000h,080h,05Ch,'Agilis(?)',0dh,0ah
 db 000h,080h,060h,'Network Interface Corporation',0dh,0ah
 db 000h,080h,062h,'Interface Co.',0dh,0ah
 db 000h,080h,069h,'Computone Systems',0dh,0ah
 db 000h,080h,06Ah,'ERI (Empac Research Inc.)',0dh,0ah
 db 000h,080h,06Ch,'Cegelec Projects Ltd',0dh,0ah
 db 000h,080h,06Dh,'Century Systems Corp.',0dh,0ah
 db 000h,080h,074h,'Fisher Controls',0dh,0ah
 db 000h,080h,07Bh,'Artel Communications Corp.',0dh,0ah
 db 000h,080h,07Ch,'FiberCom',0dh,0ah
 db 000h,080h,086h,'Computer Generation Inc.',0dh,0ah
 db 000h,080h,087h,'Okidata',0dh,0ah
 db 000h,080h,08Ah,'Summit (?)',0dh,0ah
 db 000h,080h,08Bh,'Dacoll Limited',0dh,0ah
 db 000h,080h,08Ch,'Frontier Software Development',0dh,0ah
 db 000h,080h,092h,'Japan Computer Industry, Inc.',0dh,0ah
 db 000h,080h,096h,'HDS (Human Designed Systems) X terminals',0dh,0ah
 db 000h,080h,09Dh,'Datacraft Manufacturing Pty Ltd',0dh,0ah
 db 000h,080h,09Fh,'Alcatel Business Systems',0dh,0ah
 db 000h,080h,0A1h,'Microtest',0dh,0ah
 db 000h,080h,0A3h,'Lantronix',0dh,0ah
 db 000h,080h,0ADh,'Telebit',0dh,0ah
 db 000h,080h,0AEh,'Hughes Network Systems',0dh,0ah
 db 000h,080h,0AFh,'Allumer Co., Ltd.',0dh,0ah
 db 000h,080h,0B2h,'NET  (Network Equipment Technologies)',0dh,0ah
 db 000h,080h,0C0h,'Penril (?)',0dh,0ah
 db 000h,080h,0C2h,'IEEE 802.1 Committee',0dh,0ah
 db 000h,080h,0C7h,'Xircom, Inc.',0dh,0ah
 db 000h,080h,0C8h,'D-Link (also Solectek Pocket Adapters)',0dh,0ah
 db 000h,080h,0C9h,'Alberta Microelectronic Centre',0dh,0ah
 db 000h,080h,0CEh,'Broadcast Television Systems',0dh,0ah
 db 000h,080h,0D0h,'Computer Products International',0dh,0ah
 db 000h,080h,0D3h,'Shiva Appletalk-Ethernet interface',0dh,0ah
 db 000h,080h,0D4h,'Chase Limited',0dh,0ah
 db 000h,080h,0D6h,'Apple Mac Portable(?)',0dh,0ah
 db 000h,080h,0D7h,'Fantum Electronics',0dh,0ah
 db 000h,080h,0D8h,'Network Peripherals',0dh,0ah
 db 000h,080h,0DAh,'Bruel & Kjaer',0dh,0ah
 db 000h,080h,0E3h,'Coral (?)',0dh,0ah
 db 000h,080h,0F1h,'Opus',0dh,0ah
 db 000h,080h,0F7h,'Zenith Communications Products',0dh,0ah
 db 000h,080h,0FBh,'BVM Limited',0dh,0ah
 db 000h,0AAh,000h,'Intel',0dh,0ah
 db 000h,0B0h,0D0h,'Computer Products International',0dh,0ah
 db 000h,0C0h,001h,'Diatek Patient Managment',0dh,0ah
 db 000h,0C0h,004h,'Japan Business Computer Co.Ltd',0dh,0ah
 db 000h,0C0h,016h,'Electronic Theatre Controls',0dh,0ah
 db 000h,0C0h,01Ah,'Corometrics Medical Systems',0dh,0ah
 db 000h,0C0h,01Ch,'Interlink Communications Ltd.',0dh,0ah
 db 000h,0C0h,01Dh,'Grand Junction Networks, Inc.',0dh,0ah
 db 000h,0C0h,020h,'Arco Electronic, Control Ltd.',0dh,0ah
 db 000h,0C0h,024h,'Eden Sistemas De Computacao SA',0dh,0ah
 db 000h,0C0h,025h,'Dataproducts Corporation',0dh,0ah
 db 000h,0C0h,027h,'Cipher Systems, Inc.',0dh,0ah
 db 000h,0C0h,028h,'Jasco Corporation',0dh,0ah
 db 000h,0C0h,02Bh,'Gerloff Gesellschaft Fur',0dh,0ah
 db 000h,0C0h,02Ch,'Centrum Communications, Inc.',0dh,0ah
 db 000h,0C0h,02Dh,'Fuji Photo Film Co., Ltd.',0dh,0ah
 db 000h,0C0h,030h,'Integrated Engineering B. V.',0dh,0ah
 db 000h,0C0h,031h,'Design Research Systems, Inc.',0dh,0ah
 db 000h,0C0h,032h,'I-Cubed Limited',0dh,0ah
 db 000h,0C0h,034h,'Dale Computer Corporation',0dh,0ah
 db 000h,0C0h,040h,'ECCI',0dh,0ah
 db 000h,0C0h,042h,'Datalux Corp.',0dh,0ah
 db 000h,0C0h,044h,'Emcom Corporation',0dh,0ah
 db 000h,0C0h,048h,'Bay Technical Associates',0dh,0ah
 db 000h,0C0h,04Eh,'Comtrol Corporation',0dh,0ah
 db 000h,0C0h,051h,'Advanced Integration Research',0dh,0ah
 db 000h,0C0h,05Ch,'Elonex PLC',0dh,0ah
 db 000h,0C0h,066h,'Docupoint, Inc.',0dh,0ah
 db 000h,0C0h,06Dh,'Boca Research, Inc.',0dh,0ah
 db 000h,0C0h,071h,'Areanex Communications, Inc.',0dh,0ah
 db 000h,0C0h,078h,'Computer Systems Engineering',0dh,0ah
 db 000h,0C0h,091h,'Jabil Circuit, Inc.',0dh,0ah
 db 000h,0C0h,093h,'Alta Research Corp.',0dh,0ah
 db 000h,0C0h,097h,'Archipel SA',0dh,0ah
 db 000h,0C0h,098h,'Chuntex Electronic Co., Ltd.',0dh,0ah
 db 000h,0C0h,09Dh,'Distributed Systems International, Inc',0dh,0ah
 db 000h,0C0h,0A0h,'Advance Micro Research, Inc.',0dh,0ah
 db 000h,0C0h,0A2h,'Intermedium A/S',0dh,0ah
 db 000h,0C0h,0A8h,'GVC Corporation',0dh,0ah
 db 000h,0C0h,0ACh,'Gambit Computer Communications',0dh,0ah
 db 000h,0C0h,0ADh,'Computer Communication Systems',0dh,0ah
 db 000h,0C0h,0B0h,'GCC Technologies,Inc.',0dh,0ah
 db 000h,0C0h,0B8h,"Fraser's Hill Ltd.",0dh,0ah
 db 000h,0C0h,0BDh,'Inex Technologies, Inc.',0dh,0ah
 db 000h,0C0h,0BEh,'Alcatel - Sel',0dh,0ah
 db 000h,0C0h,0C2h,'Infinite Networks Ltd.',0dh,0ah
 db 000h,0C0h,0C4h,'Computer Operational',0dh,0ah
 db 000h,0C0h,0CAh,'Alfa, Inc.',0dh,0ah
 db 000h,0C0h,0CBh,'Control Technology Corporation',0dh,0ah
 db 000h,0C0h,0D1h,'Comtree Technology Corporation',0dh,0ah
 db 000h,0C0h,0D6h,'J1 Systems, Inc.',0dh,0ah
 db 000h,0C0h,0DCh,'EOS Technologies, Inc.',0dh,0ah
 db 000h,0C0h,0E2h,'Calcomp, Inc.',0dh,0ah
 db 000h,0C0h,0E7h,'Fiberdata AB',0dh,0ah
 db 000h,0C0h,0EAh,'Array Technology Ltd.',0dh,0ah
 db 000h,0C0h,0ECh,'Dauphin Technology',0dh,0ah
 db 000h,0C0h,0EFh,'Abit Corporation',0dh,0ah
 db 000h,0C0h,0F4h,'Interlink System Co., Ltd.',0dh,0ah
 db 000h,0C0h,0F6h,'Celan Technology Inc.',0dh,0ah
 db 000h,0C0h,0F7h,'Engage Communication, Inc.',0dh,0ah
 db 000h,0C0h,0F8h,'About Computing Inc.',0dh,0ah
 db 000h,0C0h,0FBh,'Advanced Technology Labs',0dh,0ah
 db 000h,0DDh,000h,'Ungermann-Bass IBM RT',0dh,0ah
 db 000h,0DDh,001h,'Ungermann-Bass',0dh,0ah
 db 000h,0DDh,008h,'Ungermann-Bass',0dh,0ah
 db 002h,004h,006h,'BBN (Bolt Beranek and Newman, Inc.) internal usage (not registered)',0dh,0ah
 db 002h,007h,001h,'MICOM/Interlan DEC (UNIBUS or QBUS), Apollo, Cisco',0dh,0ah
 db 002h,060h,060h,'3Com',0dh,0ah
 db 002h,060h,086h,'Satelcom MegaPac (UK)',0dh,0ah
 db 002h,060h,08Ch,'3Com IBM PC; Imagen; Valid; Cisco; Macintosh',0dh,0ah
 db 002h,0CFh,01Fh,'CMC Masscomp; Silicon Graphics; Prime EXL',0dh,0ah
 db 002h,0E6h,0D3h,'BTI (Bus-Tech, Inc.) IBM Mainframes',0dh,0ah
 db 008h,000h,001h,'Computer Vision',0dh,0ah
 db 008h,000h,002h,'3Com (formerly Bridge)',0dh,0ah
 db 008h,000h,003h,'ACC (Advanced Computer Communications)',0dh,0ah
 db 008h,000h,005h,'Symbolics Symbolics LISP machines',0dh,0ah
 db 008h,000h,006h,'Siemens Nixdorf PC clone',0dh,0ah
 db 008h,000h,007h,'Apple',0dh,0ah
 db 008h,000h,008h,'BBN (Bolt Beranek and Newman, Inc.)',0dh,0ah
 db 008h,000h,009h,'Hewlett-Packard',0dh,0ah
 db 008h,000h,00Ah,'Nestar Systems',0dh,0ah
 db 008h,000h,00Bh,'Unisys',0dh,0ah
 db 008h,000h,00Dh,'ICL (International Computers, Ltd.)',0dh,0ah
 db 008h,000h,00Eh,'NCR/AT&T',0dh,0ah
 db 008h,000h,00Fh,'SMC (Standard Microsystems Corp.)',0dh,0ah
 db 008h,000h,010h,'AT&T [misrepresentation of 800010?]',0dh,0ah
 db 008h,000h,011h,'Tektronix, Inc.',0dh,0ah
 db 008h,000h,014h,'Excelan BBN Butterfly, Masscomp, Silicon Graphics',0dh,0ah
 db 008h,000h,017h,'NSC (Network System Corp.)',0dh,0ah
 db 008h,000h,01Ah,'Tiara? (used to have Data General)',0dh,0ah
 db 008h,000h,01Bh,'Data General',0dh,0ah
 db 008h,000h,01Eh,'Apollo',0dh,0ah
 db 008h,000h,01Fh,'Sharp',0dh,0ah
 db 008h,000h,020h,'Sun',0dh,0ah
 db 008h,000h,022h,'NBI (Nothing But Initials)',0dh,0ah
 db 008h,000h,023h,'Matsushita Denso',0dh,0ah
 db 008h,000h,025h,'CDC',0dh,0ah
 db 008h,000h,026h,'Norsk Data (Nord)',0dh,0ah
 db 008h,000h,027h,'PCS Computer Systems GmbH',0dh,0ah
 db 008h,000h,028h,'TI Explorer',0dh,0ah
 db 008h,000h,02Bh,'DEC',0dh,0ah
 db 008h,000h,02Eh,'Metaphor',0dh,0ah
 db 008h,000h,02Fh,'Prime Computer Prime 50-Series LHC300',0dh,0ah
 db 008h,000h,030h,'CERN',0dh,0ah
 db 008h,000h,036h,'Intergraph CAE stations',0dh,0ah
 db 008h,000h,037h,'Fujitsu-Xerox',0dh,0ah
 db 008h,000h,038h,'Bull',0dh,0ah
 db 008h,000h,039h,'Spider Systems',0dh,0ah
 db 008h,000h,03Bh,'Torus Systems',0dh,0ah
 db 008h,000h,03Eh,'Motorola VME bus processor modules',0dh,0ah
 db 008h,000h,041h,'DCA (Digital Comm. Assoc.)',0dh,0ah
 db 008h,000h,044h,'DSI (DAVID Systems, Inc.)',0dh,0ah
 db 008h,000h,045h,'???? (maybe Xylogics, but they claim not to know this number)',0dh,0ah
 db 008h,000h,046h,'Sony',0dh,0ah
 db 008h,000h,047h,'Sequent',0dh,0ah
 db 008h,000h,048h,'Eurotherm Gauging Systems',0dh,0ah
 db 008h,000h,049h,'Univation',0dh,0ah
 db 008h,000h,04Ch,'Encore',0dh,0ah
 db 008h,000h,04Eh,'BICC',0dh,0ah
 db 008h,000h,051h,'Experdata',0dh,0ah
 db 008h,000h,056h,'Stanford University',0dh,0ah
 db 008h,000h,057h,'Evans & Sutherland (?)',0dh,0ah
 db 008h,000h,058h,'??? DECsystem-20',0dh,0ah
 db 008h,000h,05Ah,'IBM',0dh,0ah
 db 008h,000h,067h,'Comdesign',0dh,0ah
 db 008h,000h,068h,'Ridge',0dh,0ah
 db 008h,000h,069h,'Silicon Graphics',0dh,0ah
 db 008h,000h,06Ah,'ATTst (?)',0dh,0ah
 db 008h,000h,06Eh,'Excelan',0dh,0ah
 db 008h,000h,070h,'Mitsubishi',0dh,0ah
 db 008h,000h,074h,'Casio',0dh,0ah
 db 008h,000h,075h,'DDE (Danish Data Elektronik A/S)',0dh,0ah
 db 008h,000h,077h,'TSL (now Retix)',0dh,0ah
 db 008h,000h,079h,'Silicon Graphics',0dh,0ah
 db 008h,000h,07Ch,'Vitalink TransLAN III',0dh,0ah
 db 008h,000h,080h,'XIOS',0dh,0ah
 db 008h,000h,081h,'Crosfield Electronics',0dh,0ah
 db 008h,000h,083h,'Seiko Denshi ',0dh,0ah
 db 008h,000h,086h,'Imagen/QMS',0dh,0ah
 db 008h,000h,087h,'Xyplex terminal servers',0dh,0ah
 db 008h,000h,089h,'Kinetics AppleTalk-Ethernet interface',0dh,0ah
 db 008h,000h,08Bh,'Pyramid',0dh,0ah
 db 008h,000h,08Dh,'XyVision XyVision machines',0dh,0ah
 db 008h,000h,08Eh,'Tandem / Solbourne Computer ?',0dh,0ah
 db 008h,000h,08Fh,'Chipcom Corp.',0dh,0ah
 db 008h,000h,090h,'Retix, Inc. Bridges',0dh,0ah
 db 010h,000h,05Ah,'IBM',0dh,0ah
 db 010h,000h,0D4h,'DEC',0dh,0ah
 db 010h,000h,0E0h,'Apple A/UX (modified addresses for licensing)',0dh,0ah
 db 040h,000h,003h,'Net Ware (?)',0dh,0ah
 db 044h,046h,049h,'DFI (Diamond Flower Industries)',0dh,0ah
 db 047h,054h,043h,'GTC (Not registered!) (This number is a multicast!)',0dh,0ah
 db 048h,044h,053h,'HDS ???',0dh,0ah
 db 080h,000h,010h,'AT&T [misrepresented as 080010? One source claims this is correct]',0dh,0ah
 db 080h,0ADh,000h,'CNET Technology Inc.',0dh,0ah
 db 0AAh,000h,000h,'DEC obsolete',0dh,0ah
 db 0AAh,000h,001h,'DEC obsolete',0dh,0ah
 db 0AAh,000h,002h,'DEC obsolete',0dh,0ah
 db 0AAh,000h,003h,'DEC Global physical address for some DEC machines',0dh,0ah
 db 0AAh,000h,004h,'DEC Local logical address for systems running DECNET',0dh,0ah
 db 0C0h,000h,000h,'Western Digital (may be reversed 00 00 C0?)',0dh,0ah
 db 0ECh,010h,000h,'Enhance Source Co., Ltd. PC clones(?)'
 db 0ffh,0ffh,0ffh
buf0	db	0,0,0,0
buf	db	40h dup (?)
P00100	ENDP
S00000	ENDS
	END	P00100
